#include "payload.h"
#include "vsi-dstrbtr.h"
#include "vsi-dstrbtr-srv.h"
#include "netutl.h"

void Usage(){
  cerr << "Usage: " << me 
       << "[-a <server ip>] [-p <srv port>]  [-h] [-q <listen mstr port>]\n";
  cerr << "[-d <listen dmy port>] [-e <debug level>] [-t <this ip>]\n";
  cerr << "[-r <Socket Rcv Bufsize>] [-s <Socket Snd Bufsize>]" << endl; 
  cerr << " Receiving VSI2000 data from server and distribute to clients.\n"; 
  cerr << " -a: Data Source Server IP.  default is localhost.\n"; 
  cerr << " -p: Data Source Server port. default is 7002.\n"; 
  cerr << " -q: Listen port to accept TCP socket connection from MASTER client" 
       << endl;
  cerr << "     Default is  7004\n"; 
  cerr << " -d: Listen port to accept TCP socket connection from DUMMY client\n"; 
  cerr << "     Default is  7005\n"; 
  cerr << " -h: Show this help" << endl;
  cerr << "  Note: Communication protocol is as follows\n";
  cerr << "   *:Accept connection and receive payload data from Master client\n";
  cerr << "   *:Accept connection from dummy server \n";
  cerr << "   *:Payload data is sent to data source server, then data is received.\n";
  cerr << "   *:Received data is sent to Master and Dummy clients..\n";
  cerr << "      --  Coded by M.S. 2007.1.9 \n";
  exit(1);
}

char* me;
int   debug_level=0;

int  main(int argc, char *argv[]) {
 /* *** Initialize *** */
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  unsigned short srv_port=7002;
  int mtu=1500;
  string srv_ip("localhost");
  unsigned short  mstr_clt_port=7004;// Default Master Client port
  unsigned short  dmy_clt_port =7005;// Default Dummy  Client port
  int so_rBufSize=16000000, so_sBufSize=16000000;
  string this_ip;

  /* * Parse command-line options, if any * */ 
  int k = 0; 
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hp:a:d:q:e:r:s:t:")) { 
    case 'h':   Usage();     break;
    case 'p':   srv_port = atoi(optarg);      break;
    case 'q':   mstr_clt_port = atoi(optarg);      break;
    case 'd':   dmy_clt_port = atoi(optarg);      break;
    case 'e':   debug_level = atoi(optarg);      break;
    case 't':   this_ip = optarg;      break;
    case 'a':   srv_ip = optarg;     break;
    case 'r':   so_rBufSize = atoi(optarg);     break;
    case 's':   so_sBufSize = atoi(optarg);     break;
    case '?':    Usage(); break;
    }
  }

  Recv_mem_simple recv_clt(mtu);
  recv_clt.Set_server(srv_ip); // sps
  recv_clt.Set_Srv_port(srv_port); // sps
  recv_clt.Set_so_rBufSize(so_rBufSize); // sps
  //  recv_clt.Set_RecvBufSize(1024); 
  
  // Setup Server for data distributuon 
  Socket *out_sock1 = new TCPSocket(mtu);
  Socket *out_sock2 = new TCPSocket(mtu);
  if(Listener(out_sock1, mstr_clt_port,this_ip)<0) exit(1);
  if(Listener(out_sock2, dmy_clt_port,this_ip) <0) exit(1);
  out_sock1->set_so_sndbuf(so_sBufSize);
  out_sock2->set_so_sndbuf(so_sBufSize);
  Mst_Data_Dstr_Server mst_dat_srv(*out_sock1);
  Dmy_Data_Dst_Server dmy_dat_srv(*out_sock2);
    
  dmy_dat_srv.Set_Master(&mst_dat_srv);
  mst_dat_srv.Set_Receiver(&recv_clt); // Set Data receiver from data src 

  // Server start
  //  mst_dat_srv.proc();
  //  mst_dat_srv.join();
  //  mst_dat_srv.thread_func();
  signal(SIGINT, SIG_IGN);

  dmy_dat_srv.proc();
  
  //  Read_out(recv_clt,10);
  
  char sRecvBuf[256];
  while(1){
    fprintf(stderr,"Terminate by \"QUIT\" \n");
    scanf("%s", sRecvBuf);
    StrUpper(sRecvBuf,strlen(sRecvBuf));
    if(strncmp(sRecvBuf,"QUIT",4)==0){
      break;
    }
  }
    
  //  recv_clt.Rm_shm();
  
  //  recv_clt.stop();
  //  recv_clt.join();
  //  delete in_sock;

  delete out_sock1;  
  delete out_sock2;

}


// const int Read_out(Recv_mem & recv_clt, int nrpt){
//   //  usleep(50);
//   for(int cnt=0; cnt<nrpt; cnt++){
//     if(recv_clt.Lock_forRead(cnt % 2) != 0){
//       fprintf(stderr,"Memory page (%d)is not available\n", cnt%2);
//       return -1;
//     }
//     u_int8_t* rdadr = recv_clt.Get_Rpoint();
//     if(rdadr ==0){
//       fprintf(stderr,"Read address is not ready\n");
//       return -1;
//     }
//     fprintf(stderr, "  Read Out data %2d-------\n", cnt);
//     for(int j=0; j<4; j++){
//       for(int i=0; i<4;i++,rdadr+=4){
// 	fprintf(stderr, "%x%x%x%x ",
// 		*rdadr, *(rdadr+1), *(rdadr+2), *(rdadr+3) );
//       }
//       fputc('\n',stderr);
//     }
//   }
//   return 0;
// }
