#include "vsi-dummy-srv.h"

void Usage(){
  cerr << "Usage: " << me 
       << " [-p <port>] [-m <TALKER|VSI2000>] [-t <this ip>] "
       << endl;
  cerr << " [-f <fname>] [-c <ch, 0--15>]" << endl;
  cerr << "Providing Dummy data to Client" << endl;
  cerr << " -m: TALKER : Sending data after connection. (default)\n";
  cerr << "   : VSI2000: Wait for payload then Sending data.\n";
  cerr << " -f: Sending contents of file instread of dummy data.\n";
  cerr << " -c: Only that channel data is counted up.\n";
  exit(1);
}

// // Binding and Listening
// int Listener(Socket* sock, const string &ip, int port){
//   int status;
  
//   fprintf(stderr,"Binding Socket to %s:%d \n", ip.c_str(), port);
//   if( sock->bind(ip,port) == -1){
//     fprintf(stderr,"Error: %s bind failed in Listener()\n", me);
//     return 0;
//   }
//   fprintf(stderr,"Listening to sender socket ...");
//   if( sock->listen() == -1){
//     fprintf(stderr,"Error: %s listen failed in Listener()\n", me);
//     return 0;
//   }else{
//     fprintf(stderr,"Successed\n");
//     fprintf(stderr,"%s DEBUG: Waiting for connection with port(%d)\n", me, port);
//   }

//   return 1;

// }


int  main(int argc, char *argv[]) {
 /* *** Initialize *** */
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  unsigned short port=7000;
  int mtu=1500;
  int mode =TALKER;
  string this_ip;
  string fname;
  int ch_id=1;

  /* * Parse command-line options, if any * */ 
  int k = 0; 
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hp:m:t:f:c:")) { 
    case 'h' :  Usage();    break;
    case 'p':   port = atoi(optarg);   break;
    case 't':   this_ip = optarg;   break;
    case 'f':   fname = optarg;   break;
    case 'c':   ch_id = atoi(optarg);   break;
    case 'm':  if(strcmp(optarg,"VSI2000") ==0)	mode = VSI2000; break;
    case '?':  Usage(); break;
    }
  }

  signal(SIGINT, SIG_IGN);
  string srv_ip("0.0.0.0");
  int status=0;
  Socket *out_sock = new TCPSocket(mtu);
  
  if( Listener(out_sock, port,this_ip) ==0){
    fprintf(stderr, "%s Listener Failed.\n", me);
    delete out_sock;
    exit(1);
  }

  // Shard Memory  Initialize
  unsigned long shm_size = 1024;
  int shemid=-1;

  ThreadDMY* threader = new ThreadDMY(*out_sock);  
  threader->Set_mode(mode);
  if(fname.length() >0){
    fprintf(stderr,"File %s will be transfered\n", fname.c_str());
    threader->Set_fname(fname);
  }else{
    threader->Set_channel(ch_id);
  }
  if((shemid = threader->shem_init(shm_size)) == -1){  
    exit(1); 
  }else{
    fprintf(stderr,"Shaed memID = %d\n", shemid);
  }
  //  threader->Set_shem(shemid, shm_size);


  fprintf(stderr,"%s DEBUG: Thread generating from main\n",me);
  threader->proc();
  //  threader->thread_func();
  
  char sRecvBuf[256];
  while(status != -1){
    fprintf(stderr,"\n Nclient=%d, ", threader->NClient());
    fprintf(stderr,"Terminate by \"QUIT\" \n");
    scanf("%s", sRecvBuf);
    StrUpper(sRecvBuf,strlen(sRecvBuf));
    if(strncmp(sRecvBuf,"QUIT",4)==0){
      break;
    }
  }

  if(shmctl(shemid,IPC_RMID,0)==-1){
    perror("shmctl");
  }

  delete threader;
  delete out_sock;
}


