/* 
 * This software is released under the terms of the MIT License(included below). 
 *  
 * Copyright (c) 2004 MIT Haystack Observatory 
 *  
 * Permission is hereby granted, free of charge, to any person obtaining a   
 * copy of this software and associated documentation files (the "Software"),    
 * to deal in the Software without restriction, including without limitation   
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,   
 * and/or sell copies of the Software, and to permit persons to whom the  
 * Software is furnished to do so, subject to the following conditions: 
 *  
 * The above copyright notice and this permission notice shall be included in    
 * all copies or substantial portions of the Software. 
 *   
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE  
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER   
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE. 
 * 
 */

using namespace std;

#include <iostream.h>
#include <RRD.h>

Uint16RRD::Uint16RRD(const u_int32_t sz, const char* file_name):
		  _db(0), _sz(sz), _file_name(file_name), _idx(0) {
	 _db=new Uint16Sample[_sz];
	 for (_idx=0; _idx<_sz; ++_idx) {
		  _db[_idx]._time=0;
		  _db[_idx]._val=0;
	 }
}

Uint16RRD::~Uint16RRD() {
	 const char* fn=_file_name.c_str();
	 ofstream out(fn);
	 out << fixed;
	 for (_idx=0; _idx<_sz; ++_idx)
		  out << _db[_idx]._time << " " << _db[_idx]._val << endl;
	 delete [] _db;
	 out.close();
	 cerr << "Finished dumping: " << _file_name << endl;
}

Uint32RRD::Uint32RRD(const u_int32_t sz, const char* file_name):
		  _db(0), _sz(sz), _file_name(file_name), _idx(0) {
	 _db=new Uint32Sample[_sz];
	 for (_idx=0; _idx<_sz; ++_idx) {
		  _db[_idx]._time=0;
		  _db[_idx]._val=0;
	 }
}

Uint32RRD::~Uint32RRD() {
	 const char* fn=_file_name.c_str();
	 ofstream out(fn);
	 out << fixed;
	 for (_idx=0; _idx<_sz; ++_idx)
		  out << _db[_idx]._time << " " << _db[_idx]._val << endl;
	 delete [] _db;
	 out.close();
    cerr << "Finished dumping: " << _file_name << endl;
}

DoubleRRD::DoubleRRD(const u_int32_t sz, const char* file_name):
		  _db(0),_sz(sz), _file_name(file_name), _idx(0) {
	 _db=new DoubleSample[_sz];
	 for (_idx=0; _idx<_sz; ++_idx) {
		  _db[_idx]._time=0;
		  _db[_idx]._val=0;
	 }
}

DoubleRRD::~DoubleRRD() {
	 const char* fn=_file_name.c_str();
	 ofstream out(fn);
	 out << fixed;
	 for (_idx=0; _idx<_sz; ++_idx)
		  out << _db[_idx]._time << " " << _db[_idx]._val << endl;
	 delete [] _db;
	 out.close();
    cerr << "Finished dumping: " << _file_name << endl;
}
