/* 
 * This software is released under the terms of the MIT License(included below). 
 *  
 * Copyright (c) 2003 MIT Haystack Observatory 
 *  
 * Permission is hereby granted, free of charge, to any person obtaining a   
 * copy of this software and associated documentation files (the "Software"),    
 * to deal in the Software without restriction, including without limitation   
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,   
 * and/or sell copies of the Software, and to permit persons to whom the  
 * Software is furnished to do so, subject to the following conditions: 
 *  
 * The above copyright notice and this permission notice shall be included in    
 * all copies or substantial portions of the Software. 
 *   
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE  
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER   
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE. 
 * 
 */

#include <unistd.h>
#include <TCPSocket.h>
#include <UDPSocket.h>
#include <RTPSocket.h>

RTPSocket::RTPSocket(Socket& s, RTPSession& rtp_session,
		     const int& mtu):
  _sock(s),
  _rtp_session(rtp_session),
  _mtu(mtu)
{
}

RTPSocket::RTPSocket(const RTPSocket& r):
  _sock(r._sock),
  _rtp_session(r._rtp_session),
  _mtu(r._mtu)
{
}

RTPSocket::~RTPSocket()
{
}

int RTPSocket::bind(const string& ip, const int& port) 
{ 
  
  return(_sock.bind(ip, port)); 
}

int RTPSocket::listen() 
{ 
  return(_sock.listen()); 
}

int RTPSocket::accept() 
{ 
  return(_sock.accept()); 
}

int RTPSocket::connect(const string& ip, const int& port) 
{ 
  return(_sock.connect(ip, port)); 
}

int RTPSocket::close() 
{ 
  return(_sock.close()); 
}

int RTPSocket::shutdown(const int& howto) 
{ 
  return(_sock.shutdown(howto)); 
}
